/*
 * CatalogueHandler.java
 *
 * Created on 10 de agosto de 2004, 18:06
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.PriceScale;
import com.fenalco.entities.SupplierProduct;
import com.fenalco.entities.SupplierProductList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet responde ante la petición de activar o desactivar un producto
 * del proveedor del catálogo de productos.
 * 
 * @author andres
 */
public class CatalogueHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Recibe una arreglo con los valores de los checkbox de activación de los
	 * productos, este arreglo lleva como valor un string con el identificador
	 * del producto del proveedor
	 * 
	 * Se un llamado a la función <CODE>changeState</CODE> de un objeto de
	 * tipo <CODE>SupplierProduct</CODE> que recibe como parámetro el id del
	 * producto <CODE>supplierProductId</CODE>, una transacción y el nuevo
	 * estado para el el producto.
	 * 
	 * Redirecciona la navegación al servlet encargado de construir la vista del
	 * proveedor catalogoproveedor <CODE>CatalogueView</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en el procesamiento de la petición
	 * @throws IOException
	 *             Excepción en la operación de escritura por el flujo <CODE>
	 *             PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url;
		String message = "";
                String message2 = "Los siguientes productos no tienen escala de precios:";
                Vector messages = new Vector();
                messages.add( message2 );

		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
                {
                        url = "/logout";
                        //message = "Sesión no iniciada";
                        message = MessageBuilder.buildMessage(15);

                }
                else
                {
                    
                    int numIds = new Integer( request.getParameter("numIds") ).intValue();
                    //System.out.println( "Num Ids:"+numIds );
                    
                    
                    boolean itemsSelected = false;
                    int[] ids = new int[numIds];
                    String[] items = new String[numIds];

                    //Verificacion de seleccion de elementos.
                    if( request.getParameterValues("item") != null )
                    {
                            items = request.getParameterValues("item");
                            itemsSelected = true;
                    }

                    Transaction t = new Transaction();
                    boolean readyToTransact = true;
                    int currentKey;
                    int activeKey;

                    User supplier = (User) session.getAttribute("user");

                    int i=0;
                    while(i<numIds)
                    {
                        ids[i] = new Integer( request.getParameter("id"+i) ).intValue();
                        i++;
                    }
                    
                    i=0;
                    //hay resultados de la búsqueda
                    boolean activate = false;
                    boolean noScale = false;
                    
                    while(i<ids.length)
                    {
                        currentKey = ids[i];
                        activate = false;
                        
                        //Hay productos seleccionados
                        if( itemsSelected )
                        {
                            for(int j=0;j<items.length;j++)
                            {
                                activeKey = new Integer( items[j] ).intValue();    
                                
                                //Hay que activar el id actual
                                if( currentKey==activeKey && PriceScale.existScale( currentKey, supplier.getCompanyId() ) )
                                {
                                    activate = true;
                                    break;
                                }
                                
                            }
                            
                        }
                        
                        if( !PriceScale.existScale(currentKey,supplier.getCompanyId() ) ){
                        
                            noScale = true;
                            messages.add( "- " + SupplierProduct.getProductName( currentKey ) );
                            
                        }
                        
                        //Cambio de estado
                        if(activate)
                        {
                            changeStatus(t, currentKey, 1);
                            /*if(!changeStatus(t, currentKey, 1))
                            {
                                readyToTransact = false;
                                break;
                            }*/
                        }
                        else
                        {
                            changeStatus(t, currentKey, 0);
                            /*if(!changeStatus(t, currentKey, 0))
                            {
                                readyToTransact = false;
                                break;
                            }*/
                        }
                        i++;
                        
                    }

                    //System.out.println( "No Scale:"+noScale );
                    //System.out.println( message2 );
                    messages.add( "Por ello no fueron activados." );
                    if( !t.execute() )
                    {
                            //Fallo en la activación de productos para el proveedor
                            url = "/proveedor/catalogoproveedor";
                            //message = "Algunos de los productos seleccionados no tienen escala de precios";
                            //message = message2;

                    }
                    else
                    {
                            //Todo OK
                            url = "/proveedor/catalogoproveedor";
                            message = "La activación de productos finalizó correctamente";
                            if( !noScale ){
                                
                                messages.clear();
                                messages.add( message );
                                
                            } 
                            
                    }

                }
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
                request.setAttribute("message", messages);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Este método permite activar o desactivar un producto del proveedor
	 * 
	 * @param supplierProductId
	 *            Identificador único del producto ofrecido por el proveedor que
	 *            solicita el cambio de estado activo / inactivo
	 * 
	 * @return Valor booleano que indica si la operación tuvo éxito o no.
	 */
	protected boolean changeStatus( Transaction t, int productKey, int newStatus )
	{
		boolean response = true;

		if( !SupplierProduct.changeStatus(t, productKey, newStatus) )
		{
			response = false;
		}

		return response;
	}
        
        
	/**
	 * Maneja el método HTTP <CODE>GET</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en el procesamiento de la petición
	 * @throws IOException
	 *             Excepción en la operación de escritura por el flujo <CODE>
	 *             PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en el procesamiento de la petición
	 * @throws IOException
	 *             Excepción en la operación de escritura por el flujo <CODE>
	 *             PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una breve descripción del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}